package dev.jansel.aglaea.utils

import com.github.philippheuer.credentialmanager.domain.OAuth2Credential
import com.github.twitch4j.TwitchClientBuilder
import com.github.twitch4j.chat.events.channel.ChannelMessageEvent
import dev.jansel.aglaea.logger
import dev.jansel.aglaea.twitchClient
import dev.kordex.core.koin.KordExKoinComponent

class Twitch : KordExKoinComponent {
	suspend fun init() {
		twitchClient = TwitchClientBuilder.builder()
			.withEnableHelix(true)
			.withEnableChat(true)
			.withChatAccount(OAuth2Credential("twitch", twitchToken))
			.withClientId(twitchcid)
			.withClientSecret(twitchcs)
			.build()

		twitchClient!!.chat.joinChannel(getTwitchNameById("120275141"))

		twitchClient!!.eventManager.onEvent(
			com.github.twitch4j.chat.events.channel.ChannelMessageEvent::class.java
		) { event ->
			logger.info { "Message from Twitch: ${event.user.name}: ${event.message}" }
		}
	}
}
